// build-and-push.js
const { exec } = require('child_process')

function buildAndPush(version) {
  const dockerImageTag = `defuj/apkt-eis:${version}`
  const command = `npm run build && docker build . -t ${dockerImageTag} && docker push ${dockerImageTag}`

  exec(command, (error, stdout, stderr) => {
    if (error) {
      console.error(`Error: ${error.message}`)
      return
    }
    if (stderr) {
      console.error(`stderr: ${stderr}`)
      return
    }
    console.log(`stdout: ${stdout}`)
  })
}

// Ambil argumen versi dari command line
const version = process.argv[2]

if (!version) {
  console.error('Usage: node build-push.js <version>')
  process.exit(1)
}

buildAndPush(version)
