
const company = "PT. PLN (Persero)";
const exportToWord = (reportMeta: any, rawData: any, filename: any, periode: any) => {
  var preHtml = `<html xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:w='urn:schemas-microsoft-com:office:word' xmlns='http://www.w3.org/TR/REC-html40'><head><meta charset='utf-8'><title>${filename}</title>
    <style type="text/css" media="print">
      @page Section1 {
          size:841.95pt 21.0cm;
          mso-page-orientation:landscape;
          margin:72.0pt 72.0pt 72.0pt 72.0pt;
          mso-header-margin:35.4pt;
          mso-footer-margin:35.4pt;
          mso-paper-source:0;
      }
      @page{
        size: landscape;
        font-size: 5px;
      }
      div.Section1 {
        page:Section1;
      }
      table.main {
        border-collapse: collapse;
        width: 100%;
        text-transform: uppercase;
        font-size: 5px;
      }
      table.main thead tr {
        background-color: #c0c0c0;
      }
  </style>
    </head><body>
   <div class="Section1">
   `;
  var tbody = '';
  var column = '';
  for (let index = 0; index < rawData.length; index++) {
    const content = rawData[index];

    column += '<tr>';

    for (let i = 0; i < content.length; i++) {
      const item = content[i];
      const colSpan = item ?
        item.colSpan ? `colspan="${item.colSpan}"`
          : '' : '';
      i === 0 ?
        column += `<td ${colSpan} align="left">${item.content}</td>`
        : column += `<td>${item}</td>`;
    }
    column += `</tr>`;
  }
  tbody += column;

  var body = `
    <table border=0 style="border:none">
    <tr>
        <td colspan="3"> ${company.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Induk Distribusi/Wilayah  </td>
      <td>:</td>
      <td> ${reportMeta.uid
      ? reportMeta.uid.name.toUpperCase()
      : 'Semua Unit Induk Distribusi/Wilayah'.toUpperCase()}</td>
    <tr>
      <td> Unit Pelaksanaan Pelayanan Pelanggan</td>
      <td>:</td>
      <td>  ${reportMeta.up3
      ? reportMeta.up3.name.toUpperCase()
      : 'Semua Unit Pelaksanaan Pelayanan Pelanggan'.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Posko</td>
      <td>:</td>
      <td> ${reportMeta.posko ? reportMeta.posko.name.toUpperCase() : 'Semua Posko'.toUpperCase()}</td>
    </tr>
    </table>
    <center><h6>${filename.toUpperCase()}</h6></center>
    <center><h6>Periode : ${periode.dateFromFormat} s/d ${periode.dateToFormat} (${periode.dayTo})<h6></center>
    <table class="main">
       <thead>
       <tbody><tr>
       <td height="20" align="center" valign="top"><b><font face="Cambria">NO</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Nama Regu</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Kode Regu</font></b></td>
       <td colspan="5" align="center" valign="top"><b><font face="Cambria">Laporan</font></b></td>
       <td colspan="16" align="center" valign="top"><b><font face="Cambria">Penyelesaian</font></b></td>
       </tr>
     <tr>
       <td rowspan="5" height="100" align="center" valign="top"><b><font face="Cambria">a</font></b></td>
       <td rowspan="5" align="center" valign="top"><b><font face="Cambria">b</font></b></td>
       <td rowspan="5" align="center" valign="top"><b><font face="Cambria">c</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Total</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Sudah Selesai</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Belum Selesai</font></b></td>
       <td colspan="8" align="center" valign="top"><b><font face="Cambria">Mobile</font></b></td>
       <td colspan="8" align="center" valign="top"><b><font face="Cambria">Non Mobile</font></b></td>
       </tr>
     <tr>
       <td rowspan="4" align="center" valign="top"><b><font face="Cambria">d=(e+g)</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Jml</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Jml</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td colspan="4" align="center" valign="top"><b><font face="Cambria">Non Marking</font></b></td>
       <td colspan="4" align="center" valign="top"><b><font face="Cambria">Marking</font></b></td>
       <td colspan="4" align="center" valign="top"><b><font face="Cambria">Non Marking</font></b></td>
       <td colspan="4" align="center" valign="top"><b><font face="Cambria">Marking</font></b></td>
       </tr>
     <tr>
       <td rowspan="3" align="center" valign="top"><b><font face="Cambria">e</font></b></td>
       <td rowspan="3" align="center" valign="top"><b><font face="Cambria">f=(e/d)*100</font></b></td>
       <td rowspan="3" align="center" valign="top"><b><font face="Cambria">g</font></b></td>
       <td rowspan="3" align="center" valign="top"><b><font face="Cambria">h=(g/d)*100</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Total</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Waktu Rata-Rata</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Total</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Waktu Rata-Rata</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Total</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Waktu Rata-Rata</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Total</font></b></td>
       <td colspan="2" align="center" valign="top"><b><font face="Cambria">Waktu Rata-Rata</font></b></td>
       </tr>
     <tr>
       <td align="center" valign="top"><b><font face="Cambria">Laporan</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Response</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Recovery</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Laporan</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Response</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Recovery</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Laporan</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Response</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Recovery</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Laporan</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">%</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Response</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">Recovery</font></b></td>
     </tr>
     <tr>
       <td align="center" valign="top"><b><font face="Cambria">i</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">j=(i/d)*100</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">k</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">l</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">m</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">n=(m/d)*100</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">o</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">p</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">q</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">r=(q/d)*100</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">s</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">t</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">u</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">v=(u/d)*100</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">w</font></b></td>
       <td align="center" valign="top"><b><font face="Cambria">x</font></b></td>
     </tr>
       </thead>
    <tbody>
    ${tbody} 
    </tbody>
    </table>
   `

  var postHtml = `<br>
      <footer>
        <p style="text-align: right; font-size: 10px;">${periode.dayTo}, ${periode.dateToFormat}</p>
        <br>
        <p style="text-align: right; font-size: 10px;">(.........................................)</p>
      </footer></div></body></html>`;

  var html = preHtml + body + postHtml;

  var url =
    "data:application/vnd.ms-word;charset=utf-8," + encodeURIComponent(html);

  filename = filename ? filename + ".doc" : "document.doc";

  var downloadLink = document.createElement("a");

  document.body.appendChild(downloadLink);

  downloadLink.href = url;

  downloadLink.download = filename;

  downloadLink.click();

  document.body.removeChild(downloadLink);
}

const exportDetailToWord = (reportMeta: any, rawData: any, filename: any, periode: any) => {
  var preHtml = `<html xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:w='urn:schemas-microsoft-com:office:word' xmlns='http://www.w3.org/TR/REC-html40'><head><meta charset='utf-8'><title>${filename}</title>
    <style type="text/css" media="print">
      @page Section1 {
          size:841.95pt 21.0cm;
          mso-page-orientation:landscape;
          margin:72.0pt 72.0pt 72.0pt 72.0pt;
          mso-header-margin:35.4pt;
          mso-footer-margin:35.4pt;
          mso-paper-source:0;
      }
      @page{
        size: landscape;
        font-size: 5px;
      }
      div.Section1 {
        page:Section1;
      }
      table.main {
        border-collapse: collapse;
        width: 100%;
        text-transform: uppercase;
        font-size: 8px;
      }
      table.main thead tr {
        background-color: #c0c0c0;
      }
  </style>
    </head><body>
   <div class="Section1">
   `;
  var tbody = ``;
  var cr = ``;
  rawData.map((item: any, i: any) => {
    cr += '<tr>';
    cr += `<td>${i + 1}</td>`;
    cr += `<td>${item.no_laporan}</td>`;
    cr += `<td>${item.waktu_lapor}</td>`;
    cr += `<td>${item.waktu_response}</td>`;
    cr += `<td>${item.waktu_recovery}</td>`;
    cr += `<td>${item.durasi_response_time}</td>`;
    cr += `<td>${item.durasi_recovery_time}</td>`;
    cr += `<td>${item.status_akhir}</td>`;
    cr += `<td>${item.referensi_marking}</td>`;
    cr += `<td>${item.idpel_nometer}</td>`;
    cr += `<td>${item.nama_pelapor}</td>`;
    cr += `<td>${item.alamat_pelapor}</td>`;
    cr += `<td>${item.no_telp_pelapor}</td>`;
    cr += `<td>${item.keterangan_pelapor}</td>`;
    cr += `<td>${item.nama_posko}</td>`;
    cr += `<td>${item.tindakan}</td>`;
    cr += `<td>${item.penyebab}</td>`;
    cr += '</tr>';
  });
  tbody += cr;

  var body = `
    <table border=0 style="border:none">
    <tr>
        <td colspan="3"> ${company.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Induk Distribusi/Wilayah  </td>
      <td>:</td>
      <td> ${reportMeta.uid
      ? reportMeta.uid.name.toUpperCase()
      : 'Semua Unit Induk Distribusi/Wilayah'.toUpperCase()}</td>
    <tr>
      <td> Unit Pelaksanaan Pelayanan Pelanggan</td>
      <td>:</td>
      <td>  ${reportMeta.up3
      ? reportMeta.up3.name.toUpperCase()
      : 'Semua Unit Pelaksanaan Pelayanan Pelanggan'.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Posko</td>
      <td>:</td>
      <td> ${reportMeta.posko ? reportMeta.posko.name.toUpperCase() : 'Semua Posko'.toUpperCase()}</td>
    </tr>
    </table>
    <center><h6>${filename.toUpperCase()}</h6></center>
    <center><h6>Periode : ${periode.dateFromFormat} s/d ${periode.dateToFormat} (${periode.dayTo})<h6></center>
    <table class="main">
       <thead>
       <tr>
          <th>No</th>
          <th>No Laporan</th>
          <th>Tgl Catat</th>
          <th>Tgl Pekerjaan</th>
          <th>Tgl Nyala</th>
          <th>Durasi Pencatatan</th>
          <th>Durasi Recovery Time</th>
          <th>Keterangan Cleansing</th>
          <th>Posko</th>
          <th>Tindakan</th>
          <th>Penyebab</th>
       </tr>
    </thead>
    <tbody>
    ${tbody} 
    </tbody>
    </table>
   `

  var postHtml = `<br>
      <footer>
        <p style="text-align: right; font-size: 10px;">${periode.dayTo}, ${periode.dateToFormat}</p>
        <br>
        <p style="text-align: right; font-size: 10px;">(.........................................)</p>
      </footer></div></body></html>`;

  var html = preHtml + body + postHtml;

  var url =
    "data:application/vnd.ms-word;charset=utf-8," + encodeURIComponent(html);

  filename = filename ? filename + ".doc" : "document.doc";

  var downloadLink = document.createElement("a");

  document.body.appendChild(downloadLink);

  downloadLink.href = url;

  downloadLink.download = filename;

  downloadLink.click();

  document.body.removeChild(downloadLink);
}

export { exportToWord, exportDetailToWord }