import { formatWaktu } from "@/components/Form/FiltersType/reference";
import { getMonthName, getMonthNameShort } from "@/utils/texts";
const day = new Date().toLocaleString('id-ID', { weekday: 'long' })
const date = new Date().getDate()
const month = new Date().toLocaleString('id-ID', { month: 'long' })
const year = new Date().getFullYear()
const company = "PT. PLN (Persero)";
const exportToWord = (reportMeta: any, rawData: any, filename: any, periode: any) => {
  var preHtml = `<html xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:w='urn:schemas-microsoft-com:office:word' xmlns='http://www.w3.org/TR/REC-html40'><head><meta charset='utf-8'><title>${filename}</title>
    <style type="text/css" media="print">
      @page Section1 {
          size:841.95pt 21.0cm;
          mso-page-orientation:landscape;
          margin:72.0pt 72.0pt 72.0pt 72.0pt;
          mso-header-margin:35.4pt;
          mso-footer-margin:35.4pt;
          mso-paper-source:0;
      }
      @page{
        size: landscape;
        font-size: 5px;
      }
      div.Section1 {
        page:Section1;
      }
      table.main {
        border-collapse: collapse;
        width: 100%;
        text-transform: uppercase;
        font-size: 8px;
      }
      table.main thead tr {
        background-color: #c0c0c0;
      }
  </style>
    </head><body>
   <div class="Section1">
   `;
  var tbody = ``;
  for (let index = 0; index < 5; index++) {
    const element = rawData[index];
    var column = `<tr>`;
    let styleTotal = '';
    for (let i = 0; i < element.length; i++) {
      const content = element[i];
      const colSpan = content?.colSpan !== undefined ? `colspan="${content.colSpan}"` : ''

      if (content && (content.content === 'TOTAL' || content.content === 'GRAND TOTAL')) {
        styleTotal = 'style="background-color: #c0c0c0; font-weight: bold;"'
      }
      i === 0 ?
        column += `<td ${styleTotal} ${colSpan} align="left">${content.content}</td>`
        : column += `<td ${styleTotal}>${content}</td>`;
    }
    column += `</tr>`;
    tbody += column;
  }
  var body = `
    <table border=0 style="border:none">
    <tr>
        <td colspan="3"> ${company.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Induk Distribusi/Wilayah  </td>
      <td>:</td>
      <td> ${reportMeta.uid
      ? reportMeta.uid.name.toUpperCase()
      : 'Semua Unit Induk Distribusi/Wilayah'.toUpperCase()}</td>
    <tr>
      <td> Unit Pelaksanaan Pelayanan Pelanggan</td>
      <td>:</td>
      <td>  ${reportMeta.up3
      ? reportMeta.up3.name.toUpperCase()
      : 'Semua Unit Pelaksanaan Pelayanan Pelanggan'.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Layanan Pelanggan</td>
      <td>:</td>
      <td> ${reportMeta.ulp ? reportMeta.ulp.name.toUpperCase() : 'Semua Unit Layanan Pelanggan'.toUpperCase()}</td>
    </tr>
    </table>
    <center><h6>${filename.toUpperCase()}</h6></center>
    
    <table class="main">
       <thead>
       <tr>
       <th rowspan="3">Nama Unit</th>
       <th colspan="6">${getMonthNameShort(reportMeta.currentMonth)} ${reportMeta.lastYear}</th>
       <th colspan="6">${getMonthNameShort(reportMeta.currentMonth)} ${reportMeta.currentYear}</th>
       <th colspan="3">Delta Penurunan</th>
       <th colspan="4">% Penurunan YoY</th>
     </tr>
     <tr>
       <th colspan="2">Keluhan</th>
       <th colspan="2">Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th colspan="2">Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th colspan="2">Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th colspan="2">Gangguan</th>
       <th>Total</th>
       <th>% Total</th>
     </tr>
     <tr>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
       <th>Keluhan</th>
       <th>Gangguan</th>
       <th>Total</th>
     </tr>
     <tr>
       <td>1</td>
       <td>2</td>
       <td>3</td>
       <td>4</td>
       <td>5</td>
       <td>6=4+5</td>
       <td>7=2+3+6</td>
       <td>8</td>
       <td>9</td>
       <td>10</td>
       <td>11</td>
       <td>12=10+11</td>
       <td>13=8+9+12</td>
       <td>14=2-8</td>
       <td>15=3-9</td>
       <td>16=6-12</td>
       <td>17=40%*(14/2)</td>
       <td>18=40%*(15/3)</td>
       <td>19=20%*(16/6)</td>
       <td>20=17+18+19</td>
     </tr>
    </thead>
    <tbody>
    ${tbody} 
    </tbody>
    </table>
   `

  var postHtml = `<br>
      <footer>
        <p style="text-align: right; font-size: 10px;">${day}, ${date}-${month}-${year}</p>
        <br>
        <p style="text-align: right; font-size: 10px;">(.........................................)</p>
      </footer></div></body></html>`;

  var html = preHtml + body + postHtml;

  var url =
    "data:application/vnd.ms-word;charset=utf-8," + encodeURIComponent(html);

  filename = filename ? filename + ".doc" : "document.doc";

  var downloadLink = document.createElement("a");

  document.body.appendChild(downloadLink);

  downloadLink.href = url;

  downloadLink.download = filename;

  downloadLink.click();

  document.body.removeChild(downloadLink);
}

const exportDetailToWord = (reportMeta: any, rawData: any, filename: any, periode: any) => {
  var preHtml = `<html xmlns:o='urn:schemas-microsoft-com:office:office' xmlns:w='urn:schemas-microsoft-com:office:word' xmlns='http://www.w3.org/TR/REC-html40'><head><meta charset='utf-8'><title>${filename}</title>
    <style type="text/css" media="print">
      @page Section1 {
          size:841.95pt 21.0cm;
          mso-page-orientation:landscape;
          margin:72.0pt 72.0pt 72.0pt 72.0pt;
          mso-header-margin:35.4pt;
          mso-footer-margin:35.4pt;
          mso-paper-source:0;
      }
      @page{
        size: landscape;
        font-size: 5px;
      }
      div.Section1 {
        page:Section1;
      }
      table.main {
        border-collapse: collapse;
        width: 100%;
        text-transform: uppercase;
        font-size: 8px;
      }
      table.main thead tr {
        background-color: #c0c0c0;
      }
  </style>
    </head><body>
   <div class="Section1">
   `;
  var tbody = ``;
  var cr = ``;
  rawData.map((item: any, i: any) => {
    cr += '<tr>';
    cr += `<td>${i + 1}</td>`;
    cr += `<td>${item.no_laporan}</td>`;
    cr += `<td>${item.nama_uid}</td>`;
    cr += `<td>${item.nama_ulp}</td>`;
    cr += `<td>${item.id_pelanggan}</td>`;
    cr += `<td>${item.nama_pelanggan}</td>`;
    cr += `<td>${item.nama_pelapor}</td>`;
    cr += `<td>${item.alamat_pelapor}</td>`;
    cr += `<td>${item.no_telp_pelapor}</td>`;
    cr += `<td>${item.keterangan_pelapor}</td>`;
    cr += `<td>${item.penyebab}</td>`;
    cr += `<td>${item.kode_gangguan}</td>`;
    cr += `<td>${item.jenis_gangguan}</td>`;
    cr += `<td>${item.durasi_response_time ? formatWaktu(item.durasi_response_time) : ''}</td>`;
    cr += `<td>${item.durasi_recovery_time ? formatWaktu(item.durasi_recovery_time) : ''}</td>`;
    cr += `<td>${item.waktu_lapor}</td>`;
    cr += '</tr>';
  });
  tbody += cr;

  var body = `
    <table border=0 style="border:none">
    <tr>
        <td colspan="3"> ${company.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Induk Distribusi/Wilayah  </td>
      <td>:</td>
      <td> ${reportMeta.uid
      ? reportMeta.uid.name.toUpperCase()
      : 'Semua Unit Induk Distribusi/Wilayah'.toUpperCase()}</td>
    <tr>
      <td> Unit Pelaksanaan Pelayanan Pelanggan</td>
      <td>:</td>
      <td>  ${reportMeta.up3
      ? reportMeta.up3.name.toUpperCase()
      : 'Semua Unit Pelaksanaan Pelayanan Pelanggan'.toUpperCase()}</td>
    </tr>
    <tr>
      <td> Unit Layanan Pelanggan</td>
      <td>:</td>
      <td> ${reportMeta.posko ? reportMeta.ulp.name.toUpperCase() : 'Semua Unit Layanan Pelanggan'.toUpperCase()}</td>
    </tr>
    </table>
    <center><h6>${filename.toUpperCase()}</h6></center>
    
    <table class="main">
       <thead>
       <tr>
      <th>No</th>
      <th>No Laporan</th>
      <th>UID/UIW</th>
      <th>UP3</th>
      <th>ULP</th>
      <th>ID Pelanggan</th>
      <th>Nama Pelanggan</th>
      <th>Nama Pelapor</th>
      <th>Alamat Pelapor</th>
      <th>No Telp Pelapor</th>
      <th>Keterangan Pelapor</th>
      <th>Penyebab</th>
      <th>Kode Gangguan</th>
      <th>Jenis Gangguan</th>
      <th>Durasi Response Time</th>
      <th>Durasi Recovery Time</th>
      <th>Tgl Lapor</th>
    </tr>
      </thead>
    <tbody>
    ${tbody} 
    </tbody>
    </table>
   `

  var postHtml = `<br>
      <footer>
        <p style="text-align: right; font-size: 10px;">${day}, ${date}-${month}-${year}</p>
        <br>
        <p style="text-align: right; font-size: 10px;">(.........................................)</p>
      </footer></div></body></html>`;

  var html = preHtml + body + postHtml;

  var url =
    "data:application/vnd.ms-word;charset=utf-8," + encodeURIComponent(html);

  filename = filename ? filename + ".doc" : "document.doc";

  var downloadLink = document.createElement("a");

  document.body.appendChild(downloadLink);

  downloadLink.href = url;

  downloadLink.download = filename;

  downloadLink.click();

  document.body.removeChild(downloadLink);
}

export { exportToWord, exportDetailToWord }